KPanelApplet class Reference (kdeui Library)

| # kdeui Library API Documentation
Overview | Class Hierarchy | Classes | Classes (annotated) | Members | Source Files

# KPanelApplet Class Reference

Implement a panel applet. KDE Panel Applet class. More...

`#include <kpanelapplet.h>`

Inheritance diagram for KPanelApplet:

[legend]
Collaboration diagram for KPanelApplet:

[legend]
List of all members.

## Public Types
enum | Type { Normal = 0, Stretch }
| This enum describes the type of the applet. More...
enum | Action { About = 1, Help = 2, Preferences = 4, ReportBug = 8 }
| This enum holds flags which can be ORed together to describe which items the context menu over the applet handle contains. More...
enum | Position { pLeft = 0, pRight, pTop, pBottom }
enum | Alignment { LeftTop = 0, Center, RightBottom }
enum | Direction { Up = 0, Down, Left, Right }
## Signals
void | updateLayout ()
| Emit this signal to make the panel relayout all applets, when you want to change your width (horizontal panel) or height (vertical panel).
void | requestFocus ()
| Request keyboard focus from the panel.
## Public Member Functions
| KPanelApplet (const QString &configFile, Type t=Normal, int actions=0, QWidget *parent=0, const char *name=0, WFlags f=0)
| Constructs a KPanelApplet just like any other widget.
| ~KPanelApplet ()
| Destructor.
virtual int | widthForHeight (int height) const
| Returns a suggested width for a given height.
virtual int | heightForWidth (int width) const
KConfig * | config () const
| Always use this KConfig object to save/load your applets configuration.
Type | type () const
int | actions () const
virtual void | action (Action a)
| Generic action dispatcher.
void | setPosition (Position p)
void | setAlignment (Alignment a)
## Protected Member Functions
virtual void | about ()
| Is called when the user selects "About" from the applet's RMB menu.
virtual void | help ()
| Is called when the user selects "Help" from the applet's RMB menu.
virtual void | preferences ()
| Is called when the user selects "Preferences" from the applet's RMB menu.
virtual void | reportBug ()
| Is called when the user selects "Report bug" from the applet's RMB menu.
Orientation | orientation () const
Position | position () const
Alignment | alignment () const
virtual void | positionChange (Position p)
| The panel on which this applet resides has changed its position.
virtual void | alignmentChange (Alignment)
| The panel on which this applet resides has changed its alignment.
virtual void | orientationChange (Orientation)
| The orientation changed to `orientation`.
Direction | popupDirection ()
| You may need this if you want to popup menus at the right position.
virtual void | popupDirectionChange (Direction)
| The popup direction changed to `direction`.
virtual void | virtual_hook (int id, void *data)
## Protected Attributes
KPanelAppletPrivate * | d

## Detailed Description

Implement a panel applet. KDE Panel Applet class.

Panel applets

- Are small applications living in the KDE panel.
- Are implemented as DSOs (Dynamic Shared Objects).

Note: For security and stability reasons the panel won't load untrusted third party applets directly into its namespace but via an external wrapper process.

The panel locates available applets by searching for applet desktop files in (ALL_KDEDIRS)/share/apps/kicker/applets. Every panel applet should install a desktop file there to be recognised by the panel.

Besides standard keys like "Name", "Comment" and "Icon" there are two panel applet specific keys:

X-KDE-Library

Used by the panel to locate the applet DSO (Dynamic Shared Object) Example: X-KDE-Library=libexampleapplet

X-KDE-UniqueApplet

Similar to KApplication and KUniqueApplication there are two types of panel applets. Use unique applets when it makes no sence to run more than one instance of a applet in the panel. A good example for unique applets is the taskbar applet. Use normal applets when you need instance specific configuration. An example is the koolclock applet where you might want to run two instances in your panel, one configured as analog clock, the other one as digital clock. X-KDE-UniqueApplet is a boolean key which defaults to "false". Example: X-KDE-UniqueApplet=true

Back to panel applet DSOs, the following conventions are used for KDE: Name: lib<appletname>applet.la LDFLAGS: -module -no-undefined

To implement a panel applet it is not enough to write a class inheriting from KPanelApplet but you also have to provide a factory function in your DSO. A sample factory function could look like this:

     extern "C"
     {
         KPanelApplet* init(QWidget *parent, const QString& configFile)
         {
             KGlobal::locale()->insertCatalogue("exampleapplet");
             return new ExampleApplet(configFile, KPanelApplet::Normal,
                           KPanelApplet::About | KPanelApplet::Help | KPanelApplet::Preferences,
                           parent, "exampleapplet");
         }
     }

Note: Don't change the factory function signature or the panel will fail to load your applet.

Author:
  Matthias Elter <elter@kde.org>

Definition at line 96 of file kpanelapplet.h.

## Member Enumeration Documentation

enum KPanelApplet::Type

| This enum describes the type of the applet. Definition at line 105 of file kpanelapplet.h. Referenced by type().

enum KPanelApplet::Action

| This enum holds flags which can be ORed together to describe which items the context menu over the applet handle contains. Definition at line 110 of file kpanelapplet.h.

## Constructor & Destructor Documentation

KPanelApplet::KPanelApplet | ( | const QString & | configFile,
|  | Type | t = Normal,
|  | int | actions = 0,
|  | QWidget * | parent = 0,
|  | const char * | name = 0,
|  | WFlags | f = 0
| ) |

  | Constructs a KPanelApplet just like any other widget. Parameters:
  configFile | The configFile handed over in the factory function.
  Type | The applet type().
  actions | Standard RMB menu actions supported by the applet (see action() ).
  parent | The pointer to the parent widget handed over in the factory function.
  name | A Qt object name for your applet.
Definition at line 30 of file kpanelapplet.cpp. References QPalette::active(), QPalette::inactive(), KStdAccel::name(), QFrame::setFrameStyle(), and QPalette::setInactive().

KPanelApplet::~KPanelApplet | ( |  | ) |

| Destructor. Definition at line 49 of file kpanelapplet.cpp.

## Member Function Documentation

virtual int KPanelApplet::widthForHeight | ( | int | height | ) | const`[inline, virtual]`

| Returns a suggested width for a given height. Every applet should reimplement this function. Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size. On a horizontal panel the applet height is fixed, the panel will call widthForHeight(int height) with `height` equal to 'the fixed applet height' when laying out the applets. The applet can now choose the other size component (width) based on the given height. The width you return is granted. Definition at line 154 of file kpanelapplet.h.

virtual int KPanelApplet::heightForWidth | ( | int | width | ) | const`[inline, virtual]`

| Returns: A suggested height for a given width. Every applet should reimplement this function. Depending on the panel orientation the height (horizontal panel) or the width (vertical panel) of the applets is fixed. The exact values of the fixed size component depend on the panel size. On a vertical panel the applet width is fixed, the panel will call heightForWidth(int width) with `width` equal to 'the fixed applet width' when layint out the applets. The applet can now choose the other size component (height) based on the given width. The height you return is granted. Definition at line 175 of file kpanelapplet.h.

KConfig* KPanelApplet::config | ( |  | ) | const`[inline]`

| Always use this KConfig object to save/load your applets configuration. For unique applets this config object will write to a config file called rc in the users local KDE directory. For normal applets this config object will write to a instance specific config file called rc in the users local KDE directory. Definition at line 186 of file kpanelapplet.h.

Type KPanelApplet::type | ( |  | ) | const`[inline]`

| Returns: Type indicating the applet's type. Type Definition at line 192 of file kpanelapplet.h. References Type.

int KPanelApplet::actions | ( |  | ) | const`[inline]`

| Returns: int indicating the supported RMB menu actions. Action Definition at line 198 of file kpanelapplet.h.

void KPanelApplet::action | ( | Action | a | ) | `[virtual]`

| Generic action dispatcher. Called when the user selects an item from the applets RMB menu. Reimplement this function to handle actions. For About, Help, Preferences and ReportBug, use the convenience handlers ref about(), help(), preferences(), reportBug() Definition at line 98 of file kpanelapplet.cpp. References about(), help(), preferences(), and reportBug().

void KPanelApplet::updateLayout | ( |  | ) | `[signal]`

| Emit this signal to make the panel relayout all applets, when you want to change your width (horizontal panel) or height (vertical panel). The panel is going to relayout all applets based on their widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel). Please note that the panel may change the applets location if the new widthForHeight(int height) (horizontal panel) or heightForWidth(int width) (vertical panel) does not fit into the current panel layout.

void KPanelApplet::requestFocus | ( |  | ) | `[signal]`

| Request keyboard focus from the panel.

virtual void KPanelApplet::about | ( |  | ) | `[inline, protected, virtual]`

| Is called when the user selects "About" from the applet's RMB menu. Reimplement this function to launch a about dialog. Note that this is called only when your applet supports the About action. See Action and KPanelApplet(). Definition at line 252 of file kpanelapplet.h. Referenced by action().

virtual void KPanelApplet::help | ( |  | ) | `[inline, protected, virtual]`

| Is called when the user selects "Help" from the applet's RMB menu. Reimplement this function to launch a manual or help page. Note that this is called only when your applet supports the Help action. See Action and KPanelApplet(). Definition at line 261 of file kpanelapplet.h. Referenced by action().

virtual void KPanelApplet::preferences | ( |  | ) | `[inline, protected, virtual]`

| Is called when the user selects "Preferences" from the applet's RMB menu. Reimplement this function to launch a preferences dialog or kcontrol module. Note that this is called only when your applet supports the preferences action. See Action and KPanelApplet(). Definition at line 270 of file kpanelapplet.h. Referenced by action().

virtual void KPanelApplet::reportBug | ( |  | ) | `[inline, protected, virtual]`

| Is called when the user selects "Report bug" from the applet's RMB menu. Reimplement this function to launch a bug reporting dialog. Note that this is called only when your applet supports the ReportBug action. See Action and KPanelApplet() Definition at line 280 of file kpanelapplet.h. Referenced by action().

Qt::Orientation KPanelApplet::orientation | ( |  | ) | const`[protected]`

| Returns: the applet's orientation. (horizontal or vertical) Definition at line 77 of file kpanelapplet.cpp. Referenced by positionChange().

Position KPanelApplet::position | ( |  | ) | const`[inline, protected]`

| Returns: the applet's position. (top, left, bottom, or right) Definition at line 289 of file kpanelapplet.h.

Alignment KPanelApplet::alignment | ( |  | ) | const`[inline, protected]`

| Returns: the applet's alignment. (top/left, center, or bottom/right) Definition at line 293 of file kpanelapplet.h.

void KPanelApplet::positionChange | ( | Position | p | ) | `[protected, virtual]`

| The panel on which this applet resides has changed its position. Reimplement this change handler in order to adjust the look of your applet. Definition at line 69 of file kpanelapplet.cpp. References orientation(), orientationChange(), popupDirection(), popupDirectionChange(), and QFrame::resizeEvent().

virtual void KPanelApplet::alignmentChange | ( | Alignment |  | ) | `[inline, protected, virtual]`

| The panel on which this applet resides has changed its alignment. Reimplement this change handler in order to adjust the look of your applet. Definition at line 307 of file kpanelapplet.h.

virtual void KPanelApplet::orientationChange | ( | Orientation |  | ) | `[inline, protected, virtual]`

| The orientation changed to `orientation`. Reimplement this change handler in order to adjust the look of your applet. This class or method is obsolete, it is provided for compatibility only. Reimplement positionChange instead. Definition at line 316 of file kpanelapplet.h. Referenced by positionChange().

KPanelApplet::Direction KPanelApplet::popupDirection | ( |  | ) | `[protected]`

| You may need this if you want to popup menus at the right position. See popupDirectionChange() This class or method is obsolete, it is provided for compatibility only. Use position() instead. Definition at line 87 of file kpanelapplet.cpp. Referenced by positionChange().

virtual void KPanelApplet::popupDirectionChange | ( | Direction |  | ) | `[inline, protected, virtual]`

| The popup direction changed to `direction`. Reimplement this change handler in order to adjust the look of your applet. This class or method is obsolete, it is provided for compatibility only. Reimplement positionChange instead. Definition at line 335 of file kpanelapplet.h. Referenced by positionChange().

The documentation for this class was generated from the following files:

- kpanelapplet.h
- kpanelapplet.cpp

This file is part of the documentation for kdelibs Version 3.1.5.
Documentation copyright © 1996-2002 the KDE developers.
Generated on Wed Jan 28 13:03:35 2004 by doxygen 1.3.4 written by Dimitri van Heesch, © 1997-2001